OGRE: Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType > Class Template Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | List of all members
Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType > Class Template Reference
Core » General

Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers. More...

`#include <OgreRadixSort.h>`

## Public Types
typedef TContainer::iterator | ContainerIter

## Public Member Functions
| RadixSort ()
| ~RadixSort ()
template<class TFunction >
void | sort (TContainer &container, TFunction func)
| Main sort function. More...

## Detailed Description

### template<class TContainer, class TContainerValueType, typename TCompValueType>
class Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType >

Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers.

Remarks
  A radix sort is a very fast sort algorithm. It doesn't use comparisons and thus is able to break the theoretical minimum O(N*logN) complexity. Radix sort is complexity O(k*N), where k is a constant. Note that radix sorting is not in-place, it requires additional storage, so it trades memory for speed. The overhead of copying means that it is only faster for fairly large datasets, so you are advised to only use it for collections of at least a few hundred items.

  This is a template class to allow it to deal with a variety of containers, and a variety of value types to sort on. In addition to providing the container and value type on construction, you also need to supply a functor object which will retrieve the value to compare on for each item in the list. For example, if you had an std::vector of by-value instances of an object of class 'Bibble', and you wanted to sort on Bibble::getDoobrie(), you'd have to firstly create a functor like this:
  struct BibbleSortFunctor
  {
  float operator()(const Bibble& val) const
  {
  return val.getDoobrie();
  }
  }
  Then, you need to declare a RadixSort class which names the container type, the value type in the container, and the type of the value you want to sort by. You can then call the sort function. E.g.
  RadixSort<BibbleList, Bibble, float> radixSorter;
  BibbleSortFunctor functor;
  radixSorter.sort(myBibbleList, functor);
  You should try to reuse RadixSort instances, since repeated allocation of the internal storage is then avoided.

Note
  Radix sorting is often associated with just unsigned integer values. Our implementation can handle both unsigned and signed integers, as well as floats (which are often not supported by other radix sorters). doubles are not supported; you will need to implement your functor object to convert to float if you wish to use this sort routine.

## Member Typedef Documentation

## ◆ ContainerIter

template<class TContainer , class TContainerValueType , typename TCompValueType >

typedef TContainer::iterator Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType >::ContainerIter

## Constructor & Destructor Documentation

## ◆ RadixSort()

template<class TContainer , class TContainerValueType , typename TCompValueType >

Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType >::RadixSort | ( |  | ) |
| inline

## ◆ ~RadixSort()

template<class TContainer , class TContainerValueType , typename TCompValueType >

Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType >::~RadixSort | ( |  | ) |
| inline

## Member Function Documentation

## ◆ sort()

template<class TContainer , class TContainerValueType , typename TCompValueType >
template<class TFunction >

void Ogre::RadixSort< TContainer, TContainerValueType, TCompValueType >::sort | ( | TContainer & | container,
|  | TFunction | func
| ) |  |
| inline

Main sort function.

Parameters

  container | A container of the type you declared when declaring
  func | A functor which returns the value for comparison when given a container value

The documentation for this class was generated from the following file:

- OgreRadixSort.h